/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the OrganizationsList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &OrganizationsList{}

// OrganizationsList struct for OrganizationsList
type OrganizationsList struct {
	Results []Organization `json:"results"`
	Total int32 `json:"total"`
}

// NewOrganizationsList instantiates a new OrganizationsList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewOrganizationsList(results []Organization, total int32) *OrganizationsList {
	this := OrganizationsList{}
	this.Results = results
	this.Total = total
	return &this
}

// NewOrganizationsListWithDefaults instantiates a new OrganizationsList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewOrganizationsListWithDefaults() *OrganizationsList {
	this := OrganizationsList{}
	return &this
}

// GetResults returns the Results field value
func (o *OrganizationsList) GetResults() []Organization {
	if o == nil {
		var ret []Organization
		return ret
	}

	return o.Results
}

// GetResultsOk returns a tuple with the Results field value
// and a boolean to check if the value has been set.
func (o *OrganizationsList) GetResultsOk() ([]Organization, bool) {
	if o == nil {
		return nil, false
	}
	return o.Results, true
}

// SetResults sets field value
func (o *OrganizationsList) SetResults(v []Organization) {
	o.Results = v
}

// GetTotal returns the Total field value
func (o *OrganizationsList) GetTotal() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Total
}

// GetTotalOk returns a tuple with the Total field value
// and a boolean to check if the value has been set.
func (o *OrganizationsList) GetTotalOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Total, true
}

// SetTotal sets field value
func (o *OrganizationsList) SetTotal(v int32) {
	o.Total = v
}

func (o OrganizationsList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o OrganizationsList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["results"] = o.Results
	toSerialize["total"] = o.Total
	return toSerialize, nil
}

type NullableOrganizationsList struct {
	value *OrganizationsList
	isSet bool
}

func (v NullableOrganizationsList) Get() *OrganizationsList {
	return v.value
}

func (v *NullableOrganizationsList) Set(val *OrganizationsList) {
	v.value = val
	v.isSet = true
}

func (v NullableOrganizationsList) IsSet() bool {
	return v.isSet
}

func (v *NullableOrganizationsList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableOrganizationsList(val *OrganizationsList) *NullableOrganizationsList {
	return &NullableOrganizationsList{value: val, isSet: true}
}

func (v NullableOrganizationsList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableOrganizationsList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


